# how to get data: python generate_data.py n_procs n_rows n_cols output_dir n_stragglers n_partitions partial_coded
bash pushout.sh ssh "rm -rf artificial-data"
# python3 generate_data.py 9 4000 100 "." 4 4 0
python3 generate_data.py --n-procs=$1 --n-rows=8000 --n-cols=100 --output-dir="./" --n-stragglers=4 --n-partitions=2 --partial_coded="False" --num-classes=$3
bash pushout.sh scp artificial-data
rm -rf figures
mkdir figures
# run scripts:
# $1: number of machines
# $2: learning rate
# $3: number of classes
echo "===================================================="
echo "Gradient Coding"
mpiexec -np $1 -hostfile hostsfile python3 coded_logreg.py -e 500 -nn $1 -nout $3 -s 8000 -f 100 -lr $2 -ns 12 -hn 64
echo "===================================================="
echo "Slow Stale"
mpiexec -np $1 -hostfile hostsfile python3 slow_steady.py -e 500 -nn $1 -nout $3 -s 8000 -f 100 -rt 4 -lr $2 -np 2 -hn 64
echo "===================================================="
echo "Pedro's Algorithm"
mpiexec -np $1 -hostfile hostsfile python3 pedro_algorithm_fresh.py -e 500 -nn $1 -nout $3 -s 8000 -f 100 -rt 4 -lr $2 -np 2 -hn 64

for f in figures/*.csv;do
mv "$f" "${f%.*}_n$1_lr_$2_nout_$3.${f##*.}"
done
