from mpi4py import MPI
import numpy
import os
import math
import time

size = MPI.COMM_WORLD.Get_size()
rank = MPI.COMM_WORLD.Get_rank()
name = MPI.Get_processor_name()
comm = MPI.COMM_WORLD
print("Hello from rank %d of %d on %s" % (rank, size, name))
threshold = size-3

if rank == 0:
    data= {'a': 1, 'b': 1}
    starttime=time.time()
    for p in range(1,size):
        comm.send(data, dest=p, tag=p)
    print('------------RANK=%d:SENT DATA FROM MASTER------------- '%rank)
    worker_results = []
    successful_indices = []
    result = 0
    while(len(worker_results) <= threshold):
        st = MPI.Status()
        comm.Probe(status=st)
        i = st.source
        worker_results.append(comm.recv(source=i,tag=0))
        successful_indices.append(i)
        result = sum(worker_results)
    print("Results: ", result, " FROM: ", successful_indices)
    endtime=time.time()
    print("Time Spent: ",endtime-starttime)
    st = MPI.Status()
    comm.Probe(status=st)
    i = st.source
    worker_results.append(comm.recv(source=i,tag=0))
    successful_indices.append(i)

else:
    data=comm.recv(source=0, tag=rank)
    print("------------RANK=%d:RECEIVED DATA FROM MASTER------------"%rank)
    z=0
    for i in range(10000000):
        z+=1
    result = data['a']*data['b']
    comm.send(result, dest=0,tag=0)
    print("------------RANK=%d:Sent RESULT(%d) back to master------------"%(rank,result))
