import numpy as np

np.random.seed(42)


def randy(
    i, j
):  # helper function to create random matrix, b/c we need x_i^0 = 1
    if j == 0:
        return 1.0
    else:
        return np.random.random_sample()


num_dt_pts = 100  # the number of desired datapoints to be simulated/created
num_of_inpt_ftrs = (
    11  # the number of desired input features in the fake data set
)
num_of_trn_sess = (
    1000  # the # of iterations of grad. dec. over the entire data
)

# x is the data set
x = np.fromfunction(
    np.vectorize(randy), (num_dt_pts, num_of_inpt_ftrs), dtype=float
)
# print("\n" + "original dataset" + "\n\n" + str(x)+ "\n\n\n")

# function to be learned / the hidden weights in goal(a, x)
a1 = np.random.randn(num_of_inpt_ftrs)
a2 = np.random.randn(num_of_inpt_ftrs)


def sigmoid(x):
    return 1 / (1 + np.exp(-x))


def goal(
    x: np.ndarray, a: np.ndarray
):  # function to be learned with a little noise
    y = []
    for z in x:
        y.append(sigmoid(np.dot(z, a)))
    return y


labels1 = np.array(goal(x, a1))
labels2 = np.array(goal(x, a2))

labels = np.hstack([labels1.reshape((-1, 1)), labels2.reshape((-1, 1))])

# print(labels)
