import numpy as np
import math


def randy(
    i, j
):  # helper function to create random matrix, b/c we need x_i^0 = 1
    if j == 0:
        return 1.0
    else:
        return np.random.random_sample()


num_dt_pts = 100  # the number of desired datapoints to be simulated/created
num_of_inpt_ftrs = (
    11  # the number of desired input features in the fake data set
)
num_of_trn_sess = (
    1000  # the # of iterations of grad. dec. over the entire data
)

# x is the data set
x = np.fromfunction(
    np.vectorize(randy), (num_dt_pts, num_of_inpt_ftrs), dtype=float
)
# print("\n" + "original dataset" + "\n\n" + str(x)+ "\n\n\n")

# function to be learned / the hidden weights in goal(a, x)
a = np.random.randint(-(2 ** 8), 2 ** 8, num_of_inpt_ftrs)


def sigmoid(x):
    return 1 / (1 + np.exp(-x))


def goal(x, a):  # function to be learned with a little noise
    y = []
    for z in x:
        y.append(sigmoid(np.dot(z, a)))
    return y


labels = goal(x, a)

# print("\n" + "labels" + "\n\n" + str(labels)+ "\n\n\n")

# the hypothesis function w=weights, x=dataset, i=datapoint
def hyp_func_at_dt_pt_i(w, x, i):
    return np.dot(x[i], w)


# the amount to change the jth weight at the ith datapoint y=labels x=dataset
# w=weights i=dt.pnt j=weightindex a=learning_rate b=regulariztion_constant
def delta(y, h, x, i, j, w, a, b):
    xij = x.item(i, j)
    yi = y[i]
    return (-1) * a * xij * (h - yi) * yi * (1 - yi) - (b * w)


# updates the weight array at the ith datapoint w=weights y=labels x=data
# i=dt.pnt hyp_func=hypothesis_function a=learning_rate b=regulariztion_constant
def update_at_dt_pt_i(wei, y, hyp_func, x, i, a, b):
    new_wei = []
    h = hyp_func(wei, x, i)
    for j, w in enumerate(wei):
        new_wei.append(w + delta(y, h, x, i, j, w, a, b))
    return new_wei


weight = np.random.uniform(-1, 1, 11)

# print("\n" + "original weights" + "\n\n" + str(weight)+ "\n\n\n")

alpha = 10 ** (-2)  # alpha is the learning rate
beta = 10 ** (
    -4
)  # beta is the "regulariztion" constant, i.e. how small you want
# you want to force the weights to be

for k in range(num_of_trn_sess):
    for i in range(num_dt_pts):
        weight = update_at_dt_pt_i(
            weight, labels, hyp_func_at_dt_pt_i, x, i, alpha, beta
        )

# print("\n" + "updated weights" + "\n\n" + str(weight)+ "\n\n\n")

final_predict = []
for i, z in enumerate(x):
    final_predict.append(hyp_func_at_dt_pt_i(weight, x, i))

# print("\n" + "labels"        + "\n\n" + str(labels)       + "\n\n\n")
# print("\n" + "final_predict" + "\n\n" + str(final_predict)+ "\n\n\n")

error_array = []
for i, z in enumerate(labels):
    error_array.append(abs(labels[i] - final_predict[i]))

# print("\n" + "error_array" + "\n\n" + str(error_array)+ "\n\n\n")

sum = 0
max = -math.inf
min = math.inf
for z in error_array:
    sum += z
    if z < min:
        min = z
    elif z > max:
        max = z
if (min ** 2) < (max ** 2):
    max_error = max
else:
    max_error = min
ave = sum / len(error_array)

print("\n\n\n" + "the average error is" + "\n\n" + str(ave) + "\n\n\n")
print("\n" + "the maximum error is" + "\n\n" + str(max_error) + "\n\n\n")
print("\n" + "true weights is" + "\n\n" + str(a) + "\n\n\n")
print("\n" + "learned weights is" + "\n\n" + str(weight) + "\n\n\n")
